# `list_update` Interface

A list-update based associative container.

Defined in: `assoc_container.hpp`

## Template Parameters

Parameter | Description | Default Value

    typename Key

Key type.

-

    typename Mapped

Mapped type.

-

    class Eq_Fn

Equivalence functor.

    std::equal_to<Key>

    class Update_Policy

Update policy (determines when an element will be moved to the front of the list.

`move_to_front_lu_policy`

    class Allocator

Allocator type.

    std::allocator<char>

## Base Classes

Class | Derivation Type

    container_base

public

## Public Types and Constants

### Policy definitions.

Type | Definition | Description

    eq_fn

    Eq_Fn

Equivalence functor type.

    update_policy

    Update_Policy

List update policy type.

    allocator

    Allocator

`Allocator` type.

## Public Methods

### Constructors, Destructor, and Related

Method | Description

      list_update
      ()

Default constructor.

    template<
        class It>
      list_update
      (It first_it,
        It last_it)

Constructor taking iterators to a range of value_types. The value_types between `first_it` and `last_it` will be inserted into the container object.

      list_update
      (const list_update &other)

Copy constructor.

    virtual
      ~list_update
      ()

Destructor.

    list_update &
      operator=
      (const list_update &other)

Assignment operator.

    void
      swap
      (list_update &other)

Swaps content.